'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-96af6326.js');
const index$1 = require('./index-4f18c0e2.js');
const utils = require('./utils-67ea6e35.js');
require('./breakpoints-8a1e87e0.js');

const stylesCss = ".z-label{display:block;padding-bottom:var(--space-unit);color:var(--color-default-text);font-family:var(--font-family-sans);font-size:var(--font-size-1);font-weight:var(--font-sb);text-align:left;text-transform:uppercase}:host{display:block;color:var(--color-form-default-text);fill:var(--color-form-default-icon);font-family:var(--font-family-sans)}:host>div.fixed{position:relative}:host>div>.header{position:relative;z-index:10;display:flex;min-height:42px;align-items:center;justify-content:space-between;padding:0 calc(var(--space-unit) * 1.5);border:var(--border-size-small) solid var(--color-form-surface04);margin:0;background-color:var(--color-form-background);border-radius:var(--border-radius-small);cursor:pointer}:host([size=\"small\"])>div>.header{min-height:34px;font-size:var(--font-size-2)}:host([size=\"x-small\"])>div>.header{min-height:30px;font-size:var(--font-size-2)}:host([size=\"x-small\"])>div>.header p.body-3{padding:calc(var(--space-unit) * 0.5) 0}:host>div>.header:hover{outline:var(--border-size-medium) solid var(--color-form-surface04);outline-offset:-2px}:host>div>div.header:focus:focus-visible{z-index:16;box-shadow:var(--shadow-focus-primary);outline:none}:host>div>.header>p.body-3{padding:var(--space-unit) 0;margin:0}:host>div>.header>p.body-3>span{font-weight:var(--font-sb)}:host>div>.header>z-icon{fill:var(--color-form-default-icon);transform:rotate(360deg);transition:all 200ms linear}:host>div>.header>z-icon.small,:host>div>.header>z-icon.x-small{--z-icon-width:16px;--z-icon-height:16px}:host>div.open>.header{border:var(--border-size-small) solid var(--color-form-active-primary);border-radius:var(--border-radius-small) var(--border-radius-small) 0 0}:host>div.disabled{pointer-events:none}:host>div.disabled .header{border-color:var(--color-form-disabled03);fill:var(--color-form-disabled01-icon)}:host>div.disabled .header>p.body-3{color:var(--color-form-disabled03)}:host>div.disabled .header>z-icon:last-child{fill:var(--color-form-disabled01-icon)}:host>div.open>.header>z-icon{fill:var(--color-form-default-icon);transform:rotate(180deg);transition:all 200ms linear}:host>div.open>div.open-combo-data{position:relative;z-index:12;padding:var(--space-unit) calc(var(--space-unit) * 2);border:var(--border-size-small) solid var(--color-form-surface03);border-top:0;background-color:var(--color-form-background);border-radius:0;box-shadow:var(--shadow-2)}:host .open .open-combo-data z-input .z-label{color:var(--color-form-default-text)}:host>div.open>div.open-combo-data>div>div{overflow:auto;max-height:235px;padding:0}:host>div.open>div.open-combo-data>z-input{width:100%;margin-bottom:calc(var(--space-unit) * 2)}:host>div.open>div.open-combo-data>div>div>ul{max-height:235px;padding:0 3px;margin:0}:host .open-combo-data z-list-element{--background-color-list-element:var(--color-form-background);--background-hover-color-list-element:var(--color-form-surface03);--background-active-color-list-element:var(--color-form-surface03)}::-webkit-scrollbar{width:6px;background:linear-gradient(to right, transparent 0 1px, var(--gray200) 1px 5px, transparent 5px 6px)}::-webkit-scrollbar-thumb{background-color:var(--color-primary01)}::-webkit-scrollbar-thumb:hover{background-color:var(--color-hover-primary)}@supports not selector(::-webkit-scrollbar-track){:host{scrollbar-color:var(--color-primary01) transparent}}:host>div.open>z-input{position:relative;z-index:1;width:238px;margin:0 calc(var(--space-unit) * 2);color:var(--color-form-active-primary)}:host>div.open>div.open-combo-data>div>div.search{overflow:hidden;max-height:none;margin-top:0}:host>div.open>div.open-combo-data>div>div.search>ul{overflow:auto;max-height:180px;padding:var(--space-unit) calc(var(--space-unit) * 2)}:host .open .open-combo-data .search .no-results{display:flex;align-items:center;column-gap:var(--space-unit)}:host>.open>.open-combo-data .search .close-search{display:flex;justify-content:center}:host>div.open>div.open-combo-data>div>div.search .close-search>a{display:inline-block;height:44px;color:var(--color-form-active-primary);cursor:pointer;font-size:14px;font-weight:var(--font-sb);line-height:44px;text-align:center;text-transform:uppercase}:host>div.open>div.open-combo-data>div>div.search .close-search>a:focus:focus-visible{box-shadow:var(--shadow-focus-primary);outline:none}:host>div.open>div.open-combo-data>div>div.check-all-wrapper{padding:calc(var(--space-unit) * 2) calc(var(--space-unit) * 0.5);border-bottom:var(--border-size-small) solid var(--gray800);margin-bottom:var(--space-unit);text-align:left}:host([size=\"small\"])>div.open>div.open-combo-data>div>div.check-all-wrapper{padding:calc(var(--space-unit) * 1.5) calc(var(--space-unit) * 0.5)}:host([size=\"x-small\"])>div.open>div.open-combo-data>div>div.check-all-wrapper{padding:var(--space-unit) calc(var(--space-unit) * 0.5)}";
const ZComboboxStyle0 = stylesCss;

const ZCombobox = class {
    watchItems() {
        this.itemsList = typeof this.items === "string" ? JSON.parse(this.items) : this.items;
        this.selectedCounter = this.itemsList.filter((item) => item.checked).length;
        this.updateRenderItemsList();
    }
    watchSearchValue() {
        this.filterItems(this.searchValue);
    }
    watchCheckboxes() {
        this.checkboxes.forEach((item, index) => item.setAttribute("tabindex", index === 0 ? "0" : "-1"));
    }
    emitComboboxChange() {
        this.comboboxChange.emit({ id: this.inputid, items: this.itemsList });
    }
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.comboboxChange = index.createEvent(this, "comboboxChange", 7);
        this.itemsList = [];
        this.inputType = index$1.InputType.TEXT;
        this.inputid = `combo-${utils.randomId()}`;
        this.items = undefined;
        this.label = undefined;
        this.disabled = false;
        this.hassearch = false;
        this.searchlabel = undefined;
        this.searchplaceholder = undefined;
        this.searchtitle = undefined;
        this.noresultslabel = "Nessun risultato";
        this.isopen = false;
        this.isfixed = false;
        this.closesearchtext = "Chiudi";
        this.hascheckall = false;
        this.checkalltext = "Seleziona tutti";
        this.uncheckalltext = "Deseleziona tutti";
        this.maxcheckableitems = 0;
        this.hasgroupitems = undefined;
        this.size = index$1.ControlSize.BIG;
        this.searchValue = undefined;
        this.selectedCounter = undefined;
        this.renderItemsList = [];
        this.focusedItemId = undefined;
        this.checkboxes = [];
        this.toggleComboBox = this.toggleComboBox.bind(this);
        this.closeFilterItems = this.closeFilterItems.bind(this);
    }
    componentWillLoad() {
        this.watchItems();
    }
    componentWillRender() {
        this.selectedCounter = this.itemsList.filter((item) => item.checked).length;
    }
    componentDidRender() {
        const checkboxes = this.getAllCheckboxes();
        if (JSON.stringify(checkboxes) !== JSON.stringify(this.checkboxes)) {
            this.checkboxes = checkboxes;
        }
    }
    getItemId(item) {
        return `combo-checkbox-${this.inputid}-${item.id}`;
    }
    getCheckboxClass() {
        return `combo-item-checkbox-input-${this.inputid}`;
    }
    getAllCheckboxes() {
        return Array.from(this.element.shadowRoot.querySelectorAll(`.${this.getCheckboxClass()} input:not([disabled])`));
    }
    getControlToListSize() {
        switch (this.size) {
            case index$1.ControlSize.X_SMALL:
                return index$1.ListSize.SMALL;
            case index$1.ControlSize.SMALL:
                return index$1.ListSize.MEDIUM;
            default:
                return index$1.ListSize.LARGE;
        }
    }
    handleSelectArrowsNavigation(e, currId) {
        if (![index$1.KeyboardCode.ARROW_DOWN, index$1.KeyboardCode.ARROW_UP].includes(e.key) || !this.isopen) {
            return;
        }
        e.preventDefault();
        e.stopPropagation();
        const currElem = this.element.shadowRoot.querySelector(`#${currId}`);
        if (!currElem) {
            return;
        }
        const checkboxes = this.checkboxes;
        if (!checkboxes.length) {
            return;
        }
        const currElemIndex = checkboxes.indexOf(currElem);
        const firstElemIndex = 0;
        const lastElemIndex = checkboxes.length - 1;
        let nextElem = null;
        if (e.key === index$1.KeyboardCode.ARROW_DOWN) {
            nextElem = currElemIndex === lastElemIndex ? checkboxes[firstElemIndex] : checkboxes[currElemIndex + 1];
        }
        else if (e.key === index$1.KeyboardCode.ARROW_UP) {
            nextElem = currElemIndex === firstElemIndex ? checkboxes[lastElemIndex] : checkboxes[currElemIndex - 1];
        }
        this.focusComboboxItem(nextElem);
    }
    handleHeaderKeyboardEvent(ev) {
        if (ev.key === index$1.KeyboardCode.SPACE) {
            ev.preventDefault();
        }
        if ((ev.key === index$1.KeyboardCode.ARROW_DOWN && !this.isopen) || (ev.key === index$1.KeyboardCode.ARROW_UP && this.isopen)) {
            this.toggleComboBox();
        }
    }
    handleCheckboxFocus(id) {
        this.focusedItemId = id;
    }
    focusComboboxItem(elem) {
        this.checkboxes.forEach(function (item) {
            item.setAttribute("tabindex", "-1");
        });
        elem.setAttribute("tabindex", "0");
        elem.focus();
    }
    updateRenderItemsList() {
        if (this.searchValue) {
            this.filterItems(this.searchValue);
        }
        else {
            this.resetRenderItemsList();
        }
    }
    resetRenderItemsList() {
        const renderItemsList = [];
        this.itemsList.forEach((item) => {
            renderItemsList.push(Object.assign({}, item));
        });
        this.renderItemsList = renderItemsList;
    }
    filterItems(value) {
        if (!value) {
            return this.closeFilterItems();
        }
        this.resetRenderItemsList();
        this.renderItemsList = this.renderItemsList.filter((item) => {
            const start = item.name.toUpperCase().indexOf(value.toUpperCase());
            const end = start + value.length;
            const newName = item.name.substring(0, start) +
                "<strong>" +
                item.name.substring(start, end) +
                "</strong>" +
                item.name.substring(end, item.name.length);
            item.name = newName;
            return start >= 0;
        });
    }
    checkAll(checked = true) {
        this.itemsList = this.itemsList.map((item) => (Object.assign(Object.assign({}, item), { checked: checked })));
        this.resetRenderItemsList();
        this.emitComboboxChange();
    }
    closeFilterItems() {
        this.searchValue = "";
        this.resetRenderItemsList();
    }
    toggleComboBox() {
        this.isopen = !this.isopen;
    }
    getComboboxA11yAttributes() {
        return {
            "role": "combobox",
            "aria-label": this.label,
            "aria-expanded": this.isopen ? "true" : "false",
            "aria-activedescendant": this.isopen ? this.focusedItemId : "",
            "aria-controls": `${this.inputid}_list`,
        };
    }
    renderHeader() {
        return (index.h("div", { class: "header", onClick: () => this.toggleComboBox(), onKeyDown: (ev) => {
                this.handleHeaderKeyboardEvent(ev);
            }, onKeyUp: (ev) => utils.handleKeyboardSubmit(ev, this.toggleComboBox), role: "button", tabindex: 0, "aria-expanded": this.isopen ? "true" : "false" }, index.h("p", { class: "body-3" }, this.label, index.h("span", null, this.selectedCounter > 0 && ` (${this.selectedCounter})`)), index.h("z-icon", { name: "caret-down", class: this.size })));
    }
    renderContent() {
        if (!this.isopen) {
            return;
        }
        return (index.h("div", { class: "open-combo-data" }, this.hassearch && this.renderSearchInput(), !this.hassearch ? index.h("span", Object.assign({}, this.getComboboxA11yAttributes())) : null, index.h("div", { role: "listbox", "aria-label": this.label, "aria-multiselectable": true, id: `${this.inputid}_list`, "aria-owns": `${this.checkboxes.map((item) => item.id).join(" ")}` }, this.hascheckall && this.renderCheckAll(), this.renderItems())));
    }
    renderItems() {
        return (index.h("div", { class: this.searchValue && "search" }, this.renderList(this.renderItemsList), this.searchValue && this.renderCloseButton()));
    }
    renderItem(item, index$2, length) {
        return (index.h("z-list-element", { id: item.id, htmlTabindex: null, dividerType: index$2 !== length - 1 ? index$1.ListDividerType.ELEMENT : index$1.ListDividerType.NONE, size: this.getControlToListSize() }, index.h("z-input", { type: index$1.InputType.CHECKBOX, checked: item.checked, htmlid: this.getItemId(item), label: item.name, class: this.getCheckboxClass(), disabled: !item.checked && this.maxcheckableitems && this.selectedCounter >= this.maxcheckableitems, size: this.size === index$1.ControlSize.X_SMALL ? index$1.ControlSize.SMALL : this.size, role: "option", "aria-selected": item.checked ? "true" : "false", onKeyDown: (e) => this.handleSelectArrowsNavigation(e, this.getItemId(item)), onInputCheck: (e) => {
                this.itemsList = this.itemsList.map((i) => {
                    if (item.id === i.id) {
                        i.checked = e.detail.checked;
                    }
                    return i;
                });
                this.updateRenderItemsList();
                this.emitComboboxChange();
            }, onInputFocus: (e) => this.handleCheckboxFocus(e.detail.id) })));
    }
    renderList(items) {
        if (!items) {
            return;
        }
        if (!items.length && this.searchValue) {
            return this.renderNoSearchResults();
        }
        if (this.hasgroupitems) {
            return this.renderGroups(items);
        }
        return (index.h("ul", { role: "none" }, items.map((item, i) => {
            return this.renderItem(item, i, items.length);
        })));
    }
    renderGroups(items) {
        const newData = items.reduce((group, item, index) => {
            var _a;
            const { category } = item;
            const zListItem = this.renderItem(item, index, items.length);
            group[category] = (_a = group[category]) !== null && _a !== void 0 ? _a : [];
            group[category].push(zListItem);
            return group;
        }, {});
        const listGroups = Object.entries(newData).map(([key, value]) => {
            return (index.h("z-list-group", { "divider-type": index$1.ListDividerType.ELEMENT }, index.h("span", { class: "body-3-sb z-list-group-title", slot: "header-title" }, key), value.map((item) => item)));
        });
        return index.h("ul", { role: "none" }, listGroups);
    }
    renderNoSearchResults() {
        return (index.h("div", { class: "no-results" }, index.h("z-icon", { name: "multiply-circle" }), index.h("span", null, this.noresultslabel)));
    }
    renderCloseButton() {
        return (index.h("div", { class: "close-search" }, index.h("a", { onClick: () => this.closeFilterItems(), onKeyUp: (e) => utils.handleKeyboardSubmit(e, this.closeFilterItems), role: "button", tabindex: 0 }, this.closesearchtext)));
    }
    renderSearchInput() {
        return (index.h("z-input", Object.assign({ htmlid: `${this.inputid}_search`, label: this.searchlabel, placeholder: this.searchplaceholder, htmltitle: this.searchtitle, type: this.inputType, value: this.searchValue, message: false, size: this.size, "aria-autocomplete": "list" }, this.getComboboxA11yAttributes(), { onKeyUp: (e) => {
                if (e.key === index$1.KeyboardCode.ESC) {
                    this.closeFilterItems();
                }
            }, onInputChange: (e) => {
                this.searchValue = e.detail.value;
            } })));
    }
    renderCheckAll() {
        if (this.searchValue) {
            return;
        }
        const checkAllId = `combo-checkbox-${this.inputid}-check-all`;
        const allChecked = this.selectedCounter === this.itemsList.length;
        return (index.h("div", { class: "check-all-wrapper" }, index.h("z-input", { type: index$1.InputType.CHECKBOX, checked: allChecked, htmlid: checkAllId, class: this.getCheckboxClass(), label: allChecked ? this.uncheckalltext : this.checkalltext, disabled: this.maxcheckableitems && this.maxcheckableitems < this.itemsList.length, size: this.size === index$1.ControlSize.X_SMALL ? index$1.ControlSize.SMALL : this.size, role: "option", "aria-selected": allChecked ? "true" : "false", onKeyDown: (e) => this.handleSelectArrowsNavigation(e, checkAllId), onInputCheck: (e) => this.checkAll(e.detail.checked), onInputFocus: (e) => this.handleCheckboxFocus(e.detail.id) })));
    }
    render() {
        return (index.h("div", { key: '5f5a261815a1e041fe8958fdd5444b7b0a49845b', "data-action": `combo-${this.inputid}`, class: { open: this.isopen, fixed: this.isfixed, disabled: this.disabled }, id: this.inputid }, this.renderHeader(), !this.disabled && this.renderContent()));
    }
    get element() { return index.getElement(this); }
    static get watchers() { return {
        "items": ["watchItems"],
        "searchValue": ["watchSearchValue"],
        "checkboxes": ["watchCheckboxes"]
    }; }
};
ZCombobox.style = ZComboboxStyle0;

exports.z_combobox = ZCombobox;

//# sourceMappingURL=z-combobox.cjs.entry.js.map