'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-96af6326.js');
const index$1 = require('./index-4f18c0e2.js');

const stylesCss = ":host{position:absolute;z-index:2;top:0;left:0;width:100%;font-family:var(--font-family-sans);font-weight:var(--font-rg)}:host>z-alert{height:calc(var(--space-unit) * 6)}.relative-container{position:relative;display:grid;align-items:center;padding:0;grid-column-gap:var(--space-unit);grid-template-columns:18px auto 46px;grid-template-rows:1fr;outline:none}.relative-container::-moz-focus-inner{border:0}.alert-external-wrapper.remove-alert{border:var(--border-size-medium) solid var(--color-background);border-top:none}:host div.add-alert{background:var(--color-inverse-success)}:host div.remove-alert{background:var(--color-inverse-warning)}:host div>.content-text{color:var(--color-surface05);font-size:14px;letter-spacing:0.16px;line-height:20px}:host div>.content-action{height:20px;color:var(--color-primary01);cursor:pointer;font-size:12px;font-weight:var(--font-sb);letter-spacing:0.32px;line-height:20px}:host div>z-icon{justify-self:center}";
const ZMyzCardAlertStyle0 = stylesCss;

const ZMyzCardAlert = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.undoAction = index.createEvent(this, "undoAction", 7);
        this.iconname = undefined;
        this.contenttext = undefined;
        this.actiontext = undefined;
        this.type = undefined;
    }
    emitUndoAction() {
        this.undoAction.emit({ actionType: this.type });
    }
    handleSpaceKeyPress(e) {
        if (e.keyCode == 32 || e.keyCode == 13) {
            e.preventDefault();
            this.emitUndoAction();
        }
    }
    handleActionButtonClick(e) {
        e.preventDefault();
        this.emitUndoAction();
    }
    retrieveClass() {
        let className = "";
        switch (this.type) {
            case "add":
                className = "add-alert";
                break;
            case "remove":
                className = "remove-alert";
                break;
            default:
                className = "";
                break;
        }
        return className;
    }
    getAlertType() {
        switch (this.type) {
            case "add":
                return index$1.AlertType.SUCCESS;
            case "remove":
                return index$1.AlertType.WARNING;
            default:
                return null;
        }
    }
    render() {
        return (index.h("div", { key: '0a19998aa8afdf605445ca6fff06226dda90bebd', class: "alert-external-wrapper " + this.retrieveClass() }, index.h("z-alert", { key: '580f27b42700aaaab04425d3c8bc60e3ecbdbc8e', type: this.getAlertType() }, index.h("div", { key: '6e8c1366ddd95e0a3ffd3048bf5915d1ca5991c8', class: "relative-container" }, index.h("z-icon", { key: 'e50f2727f14417662f9296dc52b69ab3bb7abefc', name: this.iconname, width: 18, height: 18, class: this.retrieveClass() }), index.h("span", { key: '4973c8f1184ff49f1c6267e7fff3d97aec1d871f', class: "content-text" }, this.contenttext), this.actiontext && !!this.actiontext.trim().length && (index.h("span", { key: '758357b1a5f29db6fe2c20216059ef3f086f4f15', role: "button", tabindex: "0", class: "content-action", onClick: (e) => {
                this.handleActionButtonClick(e);
            }, onKeyPress: (e) => {
                this.handleSpaceKeyPress(e);
            } }, this.actiontext))))));
    }
};
ZMyzCardAlert.style = ZMyzCardAlertStyle0;

exports.z_myz_card_alert = ZMyzCardAlert;

//# sourceMappingURL=z-myz-card-alert.cjs.entry.js.map