import { h } from "@stencil/core";
import { ControlSize, InfoRevealPosition } from "../../../beans";
/**
 * ZBookCardApp component
 * @cssprop --z-book-card-app-padding-x - set left and right padding
 * @cssprop --z-book-card-app-padding-y - set top and bottom padding
 */
export class ZBookCardApp {
    constructor() {
        this.logo = undefined;
        this.name = undefined;
        this.link = undefined;
        this.laz = true;
        this.info = undefined;
    }
    emitAppClick() {
        this.appClick.emit();
    }
    renderLaz() {
        if (this.laz) {
            return h("span", { class: "laz" }, "laZ ");
        }
        return null;
    }
    render() {
        return (h("div", { key: 'a6e90497110df5b731c4b71ab7c0c377fc3c5532' }, h("a", { key: '50ba4a41e2f0bd50b78989b60e8f1a4dfe68ef2c', class: "app z-link", href: this.link, "aria-label": `vai a ${this.laz ? "laz" : ""} ${this.name}`, onClick: () => this.emitAppClick(), target: "_blank" }, this.logo && (h("img", { key: '4c743902416ff0d2822ba9f8689bcf0eceb87b44', src: this.logo, alt: "" })), h("div", { key: 'c0e84f7a7d964c7bf6c437338ed074c2e02b1112', class: "name body-4-sb" }, this.renderLaz(), this.name)), this.info && (h("z-info-reveal", { key: '722c3d99a3865573528739b9ed51b7bfd0a425d6', icon: "info", size: ControlSize.X_SMALL, position: InfoRevealPosition.TOP_RIGHT, class: "info body-5" }, h("div", { key: '14a00ee6607d044a04054fc2cdffafe8f76098a2' }, this.info))), h("a", { key: 'd145887f5110de5c654833a1b4f9bdf3a99a6fef', class: "z-link z-link-icon", href: this.link, "aria-label": `vai a ${this.laz ? "laz" : ""} ${this.name}`, onClick: () => this.emitAppClick(), target: "_blank" }, h("z-icon", { key: 'bf032d04ef2a5cfbfbe66133b3b9598df3d3a6c3', name: "chevron-right", fill: "color-primary01-icon" }))));
    }
    static get is() { return "z-book-card-app"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() {
        return {
            "$": ["styles.css", "../../css-components/z-link/styles.css", "../../../tokens/typography.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["styles.css", "../../css-components/z-link/styles.css", "../../../tokens/typography.css"]
        };
    }
    static get properties() {
        return {
            "logo": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "App logo url"
                },
                "attribute": "logo",
                "reflect": false
            },
            "name": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "App name"
                },
                "attribute": "name",
                "reflect": false
            },
            "link": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "link to the app website"
                },
                "attribute": "link",
                "reflect": false
            },
            "laz": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "Show or hide laZ prefix before app name"
                },
                "attribute": "laz",
                "reflect": false,
                "defaultValue": "true"
            },
            "info": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "Info text to show as inforeveal"
                },
                "attribute": "info",
                "reflect": false
            }
        };
    }
    static get events() {
        return [{
                "method": "appClick",
                "name": "appClick",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": "click on app link"
                },
                "complexType": {
                    "original": "any",
                    "resolved": "any",
                    "references": {}
                }
            }];
    }
    static get elementRef() { return "hostElement"; }
}
//# sourceMappingURL=index.js.map
