import { html } from "lit";
import "./index.stories.css";
/**
 * <p>If applied to elements with CSS property "overflow:scroll", the class will apply to both the vertical AND the horizontal scrollbars. To avoid this, use "overflow-y" instead.</p>
 * Bear in mind that the scrollbar behaves in different ways depending on the browser: <br />
 *    <ul>
 *      <li>Chrome desktop + Android + MS Edge + opera:
 *        <ul>
 *          <li>primary color scrollbar thumb with right angles</li>
 *          <li>gray scrollbar track</li>
 *          <li>thumb gets darker on hover</li>
 *          <li>thumb doesn't bounce when at end of track</li>
 *        </ul>
 *      </li>
 *      <li>Safari on Mac + chromium 69 (booktab):
 *        <ul>
 *          <li>thumb bounces when at end of track</li>
 *        </ul>
 *      </li>
 *      <li>Safari on iPad:
 *        <ul>
 *          <li>no scrollbars</li>
 *        </ul>
 *      </li>
 *      <li>Chrome on iPad:
 *        <ul>
 *          <li>gray, narrower thumb</li>
 *          <li>no track</li>
 *        </ul>
 *      </li>
 *      <li>Firefox desktop:
 *        <ul>
 *          <li>thumb has border radius</li>
 *          <li>no track</li>
 *          <li>thumb gets wider on hover</li>
 *        </ul>
 *      </li>
 *      <li>Firefox on Android:
 *        <ul>
 *          <li>th scrollbar disappears if you're not actively scrolling</li>
 *          <li>thumb has border radius</li>
 *          <li>no track</li>
 *        </ul>
 *      </li>
 *      <li>Samsung browser:
 *        <ul>
 *          <li>no side margins</li>
 *        </ul>
 *      </li>
 *    </ul>
 */
const StoryMeta = {
    title: "ZScrollbar",
};
export default StoryMeta;
export const Default = {
    render: () => html `
    <div class="z-scrollbar-story">
      <div class="scrollbar-container z-scrollbar">
        <p>
          Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc sodales purus et congue pellentesque. Sed quis
          venenatis nibh. Cras ut velit vel nisl cursus euismod ac quis lorem. In eget nisl lectus. Quisque id nibh in
          nisi viverra varius vitae id est. Nulla tincidunt mi eget consequat lacinia. Quisque rhoncus dolor a tortor
          fermentum molestie. Vivamus posuere non sapien vitae auctor. Donec dignissim efficitur consectetur.
          Suspendisse eu bibendum tortor. Nulla facilisi. Mauris pharetra eleifend dolor. Morbi velit odio, mollis et
          euismod eu, imperdiet in lectus. Maecenas laoreet tellus et diam finibus blandit. Mauris aliquam quis tellus
          et congue.
        </p>
      </div>
    </div>
  `,
};
//# sourceMappingURL=index.stories.js.map
