import { Host, h } from "@stencil/core";
export class ZDragdropArea {
    constructor() {
        this.dragAndDropLabel = undefined;
        this.dragging = false;
    }
    onDrop(e) {
        e.preventDefault();
        this.dragging = false;
        if (e.dataTransfer.files.length) {
            this.fileDropped.emit(e.dataTransfer.files);
        }
    }
    render() {
        return (h(Host, { key: '190dcbcc79e4443895774274715076523f618cf2', class: { dragover: this.dragging }, onDragOver: (e) => {
                e.preventDefault();
                this.dragging = true;
            }, onDragLeave: () => {
                this.dragging = false;
            }, onDrop: this.onDrop.bind(this) }, h("div", { key: '4d80939d13543b91165c7fdb14f5ec8037464ffe', class: "dragover-container" }, h("z-button", { key: '0957633378fc64a9efa91e6cf3748480572f05b8' }, this.dragAndDropLabel)), h("slot", { key: '128c06ec19a231080cafc23108f5a82398626fc5' })));
    }
    static get is() { return "z-dragdrop-area"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() {
        return {
            "$": ["styles.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["styles.css"]
        };
    }
    static get properties() {
        return {
            "dragAndDropLabel": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "drag & drop button label"
                },
                "attribute": "drag-and-drop-label",
                "reflect": false
            }
        };
    }
    static get states() {
        return {
            "dragging": {}
        };
    }
    static get events() {
        return [{
                "method": "fileDropped",
                "name": "fileDropped",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": "Emitted when user drop one or more files"
                },
                "complexType": {
                    "original": "any",
                    "resolved": "any",
                    "references": {}
                }
            }];
    }
}
//# sourceMappingURL=index.js.map
