import { Host, h } from "@stencil/core";
import { PopoverPosition, ZChipType } from "../../../beans";
import { Breakpoints } from "../../../constants/breakpoints";
export class ZFile {
    constructor() {
        this.fileNumber = undefined;
        this.fileName = undefined;
        this.allowPopover = false;
        this.popoverVisible = false;
    }
    removeFileHandler() {
        this.removeFile.emit({ fileName: this.fileName });
        this.el.remove();
    }
    onMouseOver() {
        this.popoverVisible = true;
    }
    onMouseLeave() {
        this.popoverVisible = false;
    }
    onInteractiveIconClick() {
        this.removeFileHandler();
    }
    componentDidLoad() {
        var _a, _b;
        if (this.elementHasEllipsis() && window.innerWidth > Breakpoints.TABLET) {
            this.allowPopover = true;
        }
        (_b = (_a = this.icon) === null || _a === void 0 ? void 0 : _a.focus) === null || _b === void 0 ? void 0 : _b.call(_a);
    }
    elementHasEllipsis() {
        return this.ellipsis.offsetWidth < this.ellipsis.scrollWidth;
    }
    render() {
        return (h(Host, { key: 'b7c1c1769e8ad69c813738b1ad1ed614a42e196e' }, this.allowPopover && (h("z-popover", { key: 'eaad804518f26a1a839bc8ff14896207ee90bad8', open: this.popoverVisible, position: PopoverPosition.AUTO, bindTo: this.chip }, h("span", { key: 'eb9671344deee0deafdff01be57cd5dbf948a614', class: "body-5 tooltip-content" }, this.ellipsis.innerText))), h("z-chip", { key: '7c890fb667a33cd00290d02e42313be683e2215e', ref: (el) => (this.chip = el), id: `chip-${this.fileNumber}`, interactiveIcon: "multiply-circled", type: ZChipType.DEFAULT }, h("span", { key: 'f0a0464a0b8a3f98e94de5a4673589518f24c2a0', ref: (el) => (this.ellipsis = el), tabIndex: -1 }, this.fileName))));
    }
    static get is() { return "z-file"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["styles.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["styles.css"]
        };
    }
    static get properties() {
        return {
            "fileNumber": {
                "type": "number",
                "mutable": false,
                "complexType": {
                    "original": "number",
                    "resolved": "number",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "File chip id"
                },
                "attribute": "file-number",
                "reflect": false
            },
            "fileName": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "File name"
                },
                "attribute": "file-name",
                "reflect": false
            }
        };
    }
    static get states() {
        return {
            "allowPopover": {},
            "popoverVisible": {}
        };
    }
    static get events() {
        return [{
                "method": "removeFile",
                "name": "removeFile",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": "Emitted when a z-file component is removed from the DOM"
                },
                "complexType": {
                    "original": "any",
                    "resolved": "any",
                    "references": {}
                }
            }];
    }
    static get elementRef() { return "el"; }
    static get listeners() {
        return [{
                "name": "mouseover",
                "method": "onMouseOver",
                "target": undefined,
                "capture": false,
                "passive": true
            }, {
                "name": "mouseleave",
                "method": "onMouseLeave",
                "target": undefined,
                "capture": false,
                "passive": true
            }, {
                "name": "interactiveIconClick",
                "method": "onInteractiveIconClick",
                "target": undefined,
                "capture": false,
                "passive": false
            }];
    }
}
//# sourceMappingURL=index.js.map
