import { h } from "@stencil/core";
import { ZChipType } from "../../beans";
export class ZChip {
    constructor() {
        this.icon = undefined;
        this.type = ZChipType.DEFAULT;
        this.interactiveIcon = undefined;
        this.disabled = false;
        this.ariaLabel = "";
    }
    render() {
        return (h("div", { key: '0c1d69ed8078ff340f797d27d2b74798471c001b', class: {
                "z-chip-container": true,
                "z-chip-interactive": !!this.interactiveIcon,
                [this.type]: true,
            }, "aria-disabled": this.disabled }, this.icon && h("z-icon", { key: 'baa00891b0130541f3a820a08678d2f1eef894b7', name: this.icon }), h("slot", { key: 'd49c8dc5643a7f42f62ab086f9ae97da18aa2561' }), this.interactiveIcon && (h("button", { key: '970f2ccfd3cf3718627e8aec7bfe06d957694030', type: "button", onClick: () => this.interactiveIconClick.emit(), "aria-label": this.ariaLabel, disabled: this.disabled }, h("z-icon", { key: '68c899a4e14a204eaac9fc7d2be37dfd5af1b087', class: "interactive-icon", name: this.interactiveIcon })))));
    }
    static get is() { return "z-chip"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["styles.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["styles.css"]
        };
    }
    static get properties() {
        return {
            "icon": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "Non interactive icon"
                },
                "attribute": "icon",
                "reflect": false
            },
            "type": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "ZChipType",
                    "resolved": "ZChipType.DEFAULT | ZChipType.MEDIUM | ZChipType.SMALL",
                    "references": {
                        "ZChipType": {
                            "location": "import",
                            "path": "../../beans",
                            "id": "src/beans/index.tsx::ZChipType"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "z-chip size type, can be default, medium or small"
                },
                "attribute": "type",
                "reflect": true,
                "defaultValue": "ZChipType.DEFAULT"
            },
            "interactiveIcon": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "z-chip interactive icon"
                },
                "attribute": "interactive-icon",
                "reflect": true
            },
            "disabled": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "set z-chip as disabled"
                },
                "attribute": "disabled",
                "reflect": true,
                "defaultValue": "false"
            },
            "ariaLabel": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "z-chip aria-label string"
                },
                "attribute": "aria-label",
                "reflect": false,
                "defaultValue": "\"\""
            }
        };
    }
    static get events() {
        return [{
                "method": "interactiveIconClick",
                "name": "interactiveIconClick",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": "click on interactive icon"
                },
                "complexType": {
                    "original": "any",
                    "resolved": "any",
                    "references": {}
                }
            }];
    }
    static get elementRef() { return "el"; }
}
//# sourceMappingURL=index.js.map
