import { html } from "lit";
import { getColorTokens } from "../../utils/storybook-utils";
import "./index";
const StoryMeta = {
    title: "ZIcon",
    component: "z-icon",
    argTypes: {
        width: {
            control: {
                type: "text",
            },
        },
        height: {
            control: {
                type: "text",
            },
        },
        fill: {
            options: getColorTokens().map((token) => token.replace("--", "")),
            control: {
                type: "select",
            },
        },
    },
    args: {
        name: "download",
        height: 24,
        width: 24,
        fill: "color-primary01",
    },
};
export default StoryMeta;
export const Default = {
    render: (args) => html `<z-icon
      name="${args.name}"
      height="${args.height}"
      width="${args.width}"
      fill="${args.fill}"
    ></z-icon>`,
};
export const ZIconRem = {
    args: {
        name: "download",
        height: "1.125rem",
        width: "1.125rem",
        fill: "color-primary01",
    },
    render: (args) => html `<z-icon
      name="${args.name}"
      height="${args.height}"
      width="${args.width}"
      fill="${args.fill}"
    ></z-icon>`,
};
//# sourceMappingURL=index.stories.js.map
