import { h } from "@stencil/core";
/**
 * @slot `descrSlotName` - description content
 */
export class ZPanelElem {
    constructor() {
        this.elemid = undefined;
        this.imgurl = undefined;
        this.imgalt = undefined;
        this.linkicon = undefined;
        this.linklabel = undefined;
        this.url = undefined;
        this.target = "_blank";
        this.isdisabled = false;
        this.descrSlotName = undefined;
    }
    render() {
        const elemId = this.elemid ? this.elemid : "";
        return (h("div", { key: '0812aa28734e176eaa553ba98011e4e9c7e9522c', class: "panel-elem-container" }, (this.imgurl || this.imgalt) && (h("div", { key: 'ad62ef2a70a88716ef12b177117e820267e62762', "aria-hidden": "true", class: "panel-elem-icon" }, h("img", { key: '8891d636ff439e25801a60a14e65e4dcad6d6038', src: this.imgurl, alt: this.imgalt }))), h("div", { key: 'aa1275fe9fa4f33cf9c7151bb192e9acce2d3070', class: "panel-elem-link" }, h("a", { key: '6500ac1c11088d22b12de3c63fd8e065c0cf100d', class: {
                "z-link": true,
                "z-link-disabled": this.isdisabled,
                "z-link-icon": true,
                "z-link-blue": true,
            }, id: elemId + "link_id", href: this.url, target: this.target }, h("z-icon", { key: '143e204c1d1bd20178a46a9d77110b9219464c99', height: 14, width: 14, name: this.linkicon }), this.linklabel)), this.descrSlotName && (h("div", { key: '9215d44929526bc6e9b8034debbec3f23b00d5ef', class: "panel-elem-desc" }, h("slot", { key: '036bc705038c03e6c021807f5d2217208ec46c9c', name: this.descrSlotName })))));
    }
    static get is() { return "z-panel-elem"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["styles.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["styles.css"]
        };
    }
    static get properties() {
        return {
            "elemid": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "html element id (optional)"
                },
                "attribute": "elemid",
                "reflect": false
            },
            "imgurl": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "image url source (optional)"
                },
                "attribute": "imgurl",
                "reflect": false
            },
            "imgalt": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "alternative image text (optional)"
                },
                "attribute": "imgalt",
                "reflect": false
            },
            "linkicon": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "icon link name (optional)"
                },
                "attribute": "linkicon",
                "reflect": false
            },
            "linklabel": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "link label text"
                },
                "attribute": "linklabel",
                "reflect": false
            },
            "url": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "link url"
                },
                "attribute": "url",
                "reflect": false
            },
            "target": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "link target (optional)"
                },
                "attribute": "target",
                "reflect": false,
                "defaultValue": "\"_blank\""
            },
            "isdisabled": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "disabled status flag (optional)"
                },
                "attribute": "isdisabled",
                "reflect": false,
                "defaultValue": "false"
            },
            "descrSlotName": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "name of slot container (optional)"
                },
                "attribute": "descr-slot-name",
                "reflect": false
            }
        };
    }
}
//# sourceMappingURL=index.js.map
