import { html } from "lit";
import "../z-stepper-item/index";
import "./index";
export default {
    title: "ZStepper/ZStepper",
    component: "z-stepper",
    decorators: [(Story) => html `<div class="z-carousel-story-container">${Story()}</div>`],
    subcomponents: {
        ZStepperItem: "z-stepper-item",
    },
};
export const Default = {
    render: () => html `<script>
        const onClick = (elem) => {
          if (!elem.disabled) {
            elem.setAttribute("pressed", "");
            Array.from(document.querySelectorAll("z-stepper-item")).forEach((s) => {
              if (s === elem) {
                return;
              }
              s.pressed = false;
              s.removeAttribute("pressed");
            });
          }
        };
      </script>
      <z-stepper>
        <z-stepper-item
          index="1"
          pressed
          href="#"
          onclick="onClick(this)"
          >I tuoi dati</z-stepper-item
        >
        <z-stepper-item
          index="2"
          href="#"
          onclick="onClick(this)"
          >Le tue credenziali</z-stepper-item
        >
        <z-stepper-item
          index="3"
          href="#"
          onclick="onClick(this)"
          >Conferma</z-stepper-item
        >
      </z-stepper>`,
};
export const Completed = {
    render: () => html `<z-stepper>
      <z-stepper-item
        index="1"
        href="#"
        disabled
        >I tuoi dati</z-stepper-item
      >
      <z-stepper-item
        index="2"
        href="#"
        disabled
        >Le tue credenziali</z-stepper-item
      >
      <z-stepper-item
        index="3"
        href="#"
        pressed
        >Conferma</z-stepper-item
      >
    </z-stepper>`,
};
export const CompletedDisabled = {
    render: () => html `<z-stepper>
      <z-stepper-item
        index="1"
        disabled
        >I tuoi dati</z-stepper-item
      >
      <z-stepper-item
        index="2"
        disabled
        >Le tue credenziali</z-stepper-item
      >
      <z-stepper-item
        index="3"
        pressed
        >Conferma</z-stepper-item
      >
    </z-stepper>`,
};
export const Checked = {
    render: () => html `<z-stepper>
      <z-stepper-item
        index="1"
        checked
        >I tuoi dati</z-stepper-item
      >
      <z-stepper-item
        index="2"
        checked
        >Le tue credenziali</z-stepper-item
      >
      <z-stepper-item
        index="3"
        checked
        >Conferma</z-stepper-item
      >
    </z-stepper>`,
};
//# sourceMappingURL=index.stories.js.map
