import { html } from "lit";
import { ToastNotification, ToastNotificationTransition } from "../../beans";
import "../z-button/index";
import "./index";
const longText = "Testo decisamente lungo, che non sta su 1 sola riga. Questo testo occupa varie righe ed è un esempio di come vengono posizionati gli elementi in caso di testo lungo.";
const template = (args) => html `<div class="toast-container">
    <z-toast-notification
      heading="${args.heading}"
      message="${args.message}"
      closebutton="${args.closebutton}"
      autoclose="${args.autoclose}"
      pauseonfocusloss="${args.pauseonfocusloss}"
      type="${args.type}"
      isdraggable="${args.isdraggable}"
      draggablepercentage="${args.draggablepercentage}"
      transition="${args.transition}"
    ></z-toast-notification>
  </div>`;
const StoryMeta = {
    title: "ZToastNotification",
    component: "z-toast-notification",
    argTypes: {
        type: {
            control: {
                type: "select",
            },
            options: Object.values(ToastNotification),
        },
        transition: {
            control: {
                type: "select",
            },
            options: Object.values(ToastNotificationTransition),
        },
    },
    args: {
        heading: "Titolo",
        message: "Questo è un messaggio di prova.",
        closebutton: true,
        autoclose: null,
        pauseonfocusloss: false,
        type: ToastNotification.DARK,
        isdraggable: true,
        draggablepercentage: 80,
        transition: ToastNotificationTransition.SLIDE_IN_RIGHT,
    },
    render: (args) => template(args),
};
export default StoryMeta;
export const SlideInRight = {};
export const SlideInLeft = {
    args: {
        transition: ToastNotificationTransition.SLIDE_IN_LEFT,
    },
};
export const SlideInDownNoCloseButton = {
    args: {
        transition: ToastNotificationTransition.SLIDE_IN_DOWN,
        closebutton: false,
    },
};
export const SlideInUpLongText = {
    args: {
        transition: ToastNotificationTransition.SLIDE_IN_UP,
        message: longText,
    },
};
export const SlottedButton = {
    args: {
        transition: ToastNotificationTransition.SLIDE_IN_DOWN,
    },
    render: (args) => html `<div class="toast-container slotted-button">
      <z-toast-notification
        heading="${args.heading}"
        message="${args.message}"
        closebutton="${args.closebutton}"
        autoclose="${args.autoclose}"
        pauseonfocusloss="${args.pauseonfocusloss}"
        type="${args.type}"
        isdraggable="${args.isdraggable}"
        draggablepercentage="${args.draggablepercentage}"
        transition="${args.transition}"
      >
        <z-button
          slot="button"
          size="small"
          variant="tertiary"
          >button</z-button
        >
      </z-toast-notification>
    </div>`,
};
export const SlottedButtonLongText = {
    args: {
        transition: ToastNotificationTransition.SLIDE_IN_DOWN,
    },
    render: (args) => html `<div class="toast-container slotted-button">
      <z-toast-notification
        heading="Titolo abbastanza lungo"
        message=${longText}
        closebutton="${args.closebutton}"
        autoclose="${args.autoclose}"
        pauseonfocusloss="${args.pauseonfocusloss}"
        type="${args.type}"
        isdraggable="${args.isdraggable}"
        draggablepercentage="${args.draggablepercentage}"
        transition="${args.transition}"
      >
        <z-button
          slot="button"
          size="small"
          variant="tertiary"
          >button</z-button
        >
      </z-toast-notification>
    </div>`,
};
//# sourceMappingURL=index.stories.js.map
