import { Host, h } from "@stencil/core";
import { LabelPosition } from "../../beans";
import { randomId } from "../../utils/utils";
export class ZToggleSwitch {
    constructor() {
        this.disabled = false;
        this.labelPosition = LabelPosition.LEFT;
        this.checked = false;
        this.htmlid = `toggle-switch-id-${randomId()}`;
    }
    emitToggleClick() {
        this.toggleClick.emit({
            id: this.htmlid,
            checked: this.checked,
        });
    }
    handleClick(ev) {
        if (this.disabled) {
            return;
        }
        this.checked = ev.target.checked;
        this.emitToggleClick();
    }
    render() {
        return (h(Host, { key: '5c2fa5cdb898b1948d3961780c5fa72786c2e6bc' }, h("input", { key: '3471fe87f44daf4a9c7a197f9d7d7349736c9823', id: this.htmlid, type: "checkbox", checked: this.checked, disabled: this.disabled, onChange: this.handleClick.bind(this) }), h("label", { key: '6fcbb7ff25810d00f311c22be960ff04f900907b', htmlFor: this.htmlid, class: {
                [this.labelPosition]: true,
                disabled: this.disabled,
            } }, h("span", { key: '6f734eaac90511fd4939b4f8bab2632f8ad24c6d' }, h("slot", { key: '0b7b519ae530e0ebf6b4b3ea0199e8b0d54094da' })), h("span", { key: 'b41791cbd5aa569a3f1361dd5881b86cb3aa0322', class: {
                container: true,
                disabled: this.disabled,
                checked: this.checked,
            } }, h("span", { key: 'f79160dde4dda3a3988e57fa5addb698573acde5', class: "circle" }, this.checked && (h("z-icon", { key: '011bd9649c7cb1c08f5ee7dd534edbe11fe7706f', width: 12, height: 12, name: "checkmark" })))))));
    }
    static get is() { return "z-toggle-switch"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["styles.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["styles.css"]
        };
    }
    static get properties() {
        return {
            "disabled": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "Disabled flag"
                },
                "attribute": "disabled",
                "reflect": true,
                "defaultValue": "false"
            },
            "labelPosition": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "LabelPosition",
                    "resolved": "LabelPosition.LEFT | LabelPosition.RIGHT",
                    "references": {
                        "LabelPosition": {
                            "location": "import",
                            "path": "../../beans",
                            "id": "src/beans/index.tsx::LabelPosition"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "Label position"
                },
                "attribute": "label-position",
                "reflect": true,
                "defaultValue": "LabelPosition.LEFT"
            },
            "checked": {
                "type": "boolean",
                "mutable": true,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "Checked state"
                },
                "attribute": "checked",
                "reflect": false,
                "defaultValue": "false"
            },
            "htmlid": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "HTML id attribute to set to the internal checkbox"
                },
                "attribute": "htmlid",
                "reflect": false,
                "defaultValue": "`toggle-switch-id-${randomId()}`"
            }
        };
    }
    static get events() {
        return [{
                "method": "toggleClick",
                "name": "toggleClick",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": "Toggle click event"
                },
                "complexType": {
                    "original": "any",
                    "resolved": "any",
                    "references": {}
                }
            }];
    }
}
//# sourceMappingURL=index.js.map
