import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { d as defineCustomElement$1 } from './index9.js';

const stylesCss = ":host{display:flex;min-height:calc(var(--space-unit) * 2.5);align-items:start;margin-top:var(--space-unit);color:var(--color-default-text);fill:currentcolor;font-family:var(--font-family-sans);font-size:var(--font-size-2);letter-spacing:0.16px}:host(.small),:host(.x-small){margin-top:calc(var(--space-unit) * 0.5);font-size:var(--font-size-1)}:host([status=\"success\"]){color:var(--color-hover-success)}:host([status=\"error\"]){color:var(--color-hover-error)}:host([status=\"warning\"]){color:var(--color-hover-warning)}:host(:focus){outline:none}:host>z-icon{--z-icon-width:calc(var(--space-unit) * 2);--z-icon-height:calc(var(--space-unit) * 2);--z-icon-right-margin:var(--space-unit);margin-top:calc(var(--space-unit) * 0.25)}:host(.small)>z-icon,:host(.x-small)>z-icon{--z-icon-width:14px;--z-icon-height:14px;--z-icon-right-margin:calc(var(--space-unit) * 0.5)}:host([disabled]){color:var(--color-disabled03);fill:var(--color-disabled03)}";
const ZInputMessageStyle0 = stylesCss;

const ZInputMessage = /*@__PURE__*/ proxyCustomElement(class ZInputMessage extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.statusIcons = {
            success: "checkmark-circle",
            error: "multiply-circled",
            warning: "exclamation-circle",
        };
        this.message = undefined;
        this.status = undefined;
        this.disabled = undefined;
        this.statusRole = {};
    }
    onMessageChange() {
        this.statusRole = this.message && this.status ? { role: "alert" } : {};
    }
    componentWillLoad() {
        this.onMessageChange();
    }
    render() {
        return (h(Host, Object.assign({ key: 'ef26c50e4e8f21bed23b6b530f34866bb9d746af' }, this.statusRole, { "aria-label": this.message }), this.statusIcons[this.status] && this.message && h("z-icon", { key: '1c701e5f10e96e549fc3e799cbc16099f2032956', name: this.statusIcons[this.status] }), h("span", { key: '9a12b124d65a4b4ebcb9856ce6e9fa275d96ac64', innerHTML: this.message })));
    }
    static get watchers() { return {
        "message": ["onMessageChange"],
        "status": ["onMessageChange"]
    }; }
    static get style() { return ZInputMessageStyle0; }
}, [1, "z-input-message", {
        "message": [1],
        "status": [513],
        "disabled": [516],
        "statusRole": [32]
    }, undefined, {
        "message": ["onMessageChange"],
        "status": ["onMessageChange"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["z-input-message", "z-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "z-input-message":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, ZInputMessage);
            }
            break;
        case "z-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { ZInputMessage as Z, defineCustomElement as d };

//# sourceMappingURL=index12.js.map