import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { d as defineCustomElement$2 } from './index4.js';
import { d as defineCustomElement$1 } from './index9.js';

const stylesCss = ":host{position:relative;display:flex;width:100%;height:232px;flex-direction:column;align-items:center;padding:calc(var(--space-unit) * 3);background-color:var(--color-surface02);background-image:repeating-linear-gradient(\n      0deg,\n      var(--color-surface03),\n      var(--color-surface03) 12px,\n      transparent 12px,\n      transparent 20px\n    ),\n    repeating-linear-gradient(\n      90deg,\n      var(--color-surface03),\n      var(--color-surface03) 12px,\n      transparent 12px,\n      transparent 20px\n    ),\n    repeating-linear-gradient(\n      180deg,\n      var(--color-surface03),\n      var(--color-surface03) 12px,\n      transparent 12px,\n      transparent 20px\n    ),\n    repeating-linear-gradient(\n      270deg,\n      var(--color-surface03),\n      var(--color-surface03) 12px,\n      transparent 12px,\n      transparent 20px\n    );background-position:0 0,\n    0 0,\n    100% 0,\n    0 100%;background-repeat:no-repeat;background-size:2px 100%,\n    100% 2px,\n    2px 100%,\n    100% 2px;border-radius:var(--border-radius-small);color:var(--color-default-text);font-family:var(--font-family-sans);font-weight:var(--font-rg)}:host,*{box-sizing:border-box}:host(.dragover) *{pointer-events:none}.dragover-container{position:absolute;z-index:1;top:0;left:0;display:none;width:100%;height:100%;background-color:var(--color-primary03);box-shadow:var(--shadow-focus-primary)}:host(.dragover) .dragover-container{display:flex;align-items:center;justify-content:center}";
const ZDragdropAreaStyle0 = stylesCss;

const ZDragdropArea = /*@__PURE__*/ proxyCustomElement(class ZDragdropArea extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.fileDropped = createEvent(this, "fileDropped", 7);
        this.dragAndDropLabel = undefined;
        this.dragging = false;
    }
    onDrop(e) {
        e.preventDefault();
        this.dragging = false;
        if (e.dataTransfer.files.length) {
            this.fileDropped.emit(e.dataTransfer.files);
        }
    }
    render() {
        return (h(Host, { key: '190dcbcc79e4443895774274715076523f618cf2', class: { dragover: this.dragging }, onDragOver: (e) => {
                e.preventDefault();
                this.dragging = true;
            }, onDragLeave: () => {
                this.dragging = false;
            }, onDrop: this.onDrop.bind(this) }, h("div", { key: '4d80939d13543b91165c7fdb14f5ec8037464ffe', class: "dragover-container" }, h("z-button", { key: '0957633378fc64a9efa91e6cf3748480572f05b8' }, this.dragAndDropLabel)), h("slot", { key: '128c06ec19a231080cafc23108f5a82398626fc5' })));
    }
    static get style() { return ZDragdropAreaStyle0; }
}, [1, "z-dragdrop-area", {
        "dragAndDropLabel": [1, "drag-and-drop-label"],
        "dragging": [32]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["z-dragdrop-area", "z-button", "z-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "z-dragdrop-area":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, ZDragdropArea);
            }
            break;
        case "z-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "z-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { ZDragdropArea as Z, defineCustomElement as d };

//# sourceMappingURL=index7.js.map