import { proxyCustomElement, HTMLElement, createEvent, h } from '@stencil/core/internal/client';
import { e as ControlSize, g as KeyboardCode, l as ListDividerType, i as ListSize } from './index2.js';
import { r as randomId, b as boolean, d as getElementTree, h as handleKeyboardSubmit, e as getClickedElement } from './utils.js';
import { d as defineCustomElement$9 } from './index6.js';
import { d as defineCustomElement$8 } from './index9.js';
import { d as defineCustomElement$7 } from './index11.js';
import { d as defineCustomElement$6 } from './index12.js';
import { d as defineCustomElement$5 } from './index13.js';
import { d as defineCustomElement$4 } from './index14.js';
import { d as defineCustomElement$3 } from './index15.js';
import { d as defineCustomElement$2 } from './index25.js';

const stylesCss = ".sc-z-select-h{display:inline-block;width:inherit;color:var(--color-form-default-text);font-family:var(--font-family-sans);font-size:var(--font-size-3);font-weight:var(--font-rg)}[size=\"small\"].sc-z-select-h,[size=\"x-small\"].sc-z-select-h{font-size:var(--font-size-2)}.select-wrapper.sc-z-select>z-input.sc-z-select{width:100%}.select-wrapper.sc-z-select>z-input.sc-z-select .input-icon.sc-z-select{cursor:pointer}.select-wrapper.sc-z-select>div.sc-z-select{position:relative}.select-wrapper.sc-z-select>div.closed.sc-z-select{overflow:hidden;height:0}.select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select{position:absolute;width:100%;box-sizing:border-box;border-top:none;background:var(--color-form-background);box-shadow:var(--shadow-2);outline:none}.select-wrapper.sc-z-select .closed.sc-z-select .ul-scroll-wrapper.sc-z-select{z-index:10}.select-wrapper.sc-z-select .open.sc-z-select .ul-scroll-wrapper.sc-z-select{z-index:20}.select-wrapper.sc-z-select .ul-scroll-wrapper.fixed.sc-z-select{position:static}.select-wrapper.sc-z-select z-list.sc-z-select{--background-color-list-element:var(--color-form-background);--background-hover-color-list-element:var(--color-form-surface03);--background-active-color-list-element:var(--color-form-surface03)}.select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select>z-list.sc-z-select{position:relative;overflow:auto;max-height:240px;padding:0 calc(var(--space-unit) * 1.5);outline:none}.select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select z-list.sc-z-select z-list-element[disabled].sc-z-select{color:var(--color-form-disabled03)}.select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select z-list.sc-z-select z-list-element.sc-z-select .list-element-container.sc-z-select{display:flex;align-items:center;padding:calc(var(--space-unit) / 2) var(--space-unit);column-gap:var(--space-unit)}.select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select z-list.sc-z-select z-list-element.sc-z-select .list-element-container.sc-z-select .list-element-content.sc-z-select{margin-right:auto}.select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select z-list.sc-z-select z-list-element.sc-z-select .list-element-container.sc-z-select>z-icon.sc-z-select+.list-element-content.sc-z-select{padding:calc(var(--space-unit) * 0.5) var(--space-unit)}[size=\"x-small\"].sc-z-select-h .select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select z-list.sc-z-select z-list-element.sc-z-select .list-element-container.sc-z-select .list-element-content.sc-z-select{padding:0}[size=\"small\"].sc-z-select-h .select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select z-list.sc-z-select z-list-element.sc-z-select .list-element-container.sc-z-select>z-icon.sc-z-select{--z-icon-width:16px;--z-icon-height:16px}[size=\"x-small\"].sc-z-select-h .select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select z-list.sc-z-select z-list-element.sc-z-select .list-element-container.sc-z-select>z-icon.sc-z-select{--z-icon-width:14px;--z-icon-height:14px}[size=\"x-small\"].sc-z-select-h .select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select z-list.sc-z-select z-list-element.sc-z-select .list-element-container.sc-z-select>z-icon.sc-z-select+.list-element-content.sc-z-select{padding:0 var(--space-unit)}.select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select z-list.sc-z-select z-list-element.sc-z-select .list-element-container.sc-z-select .list-element-content.selected.sc-z-select{font-weight:var(--font-sb)}.select-wrapper.sc-z-select .ul-scroll-wrapper.sc-z-select .no-results.sc-z-select z-icon.sc-z-select{margin-right:var(--space-unit)}.z-list-group-title.sc-z-select{color:var(--color-form-default-text)}.reset-item.sc-z-select{color:var(--color-form-active-primary);fill:var(--color-form-active-primary)}.reset-item-content.sc-z-select{display:flex;align-items:center}.reset-item.reset-item-margin.sc-z-select .reset-item-content.sc-z-select{margin-left:var(--space-unit)}.reset-item.sc-z-select .reset-item-content.sc-z-select>z-icon.sc-z-select{margin-right:var(--space-unit)}.reset-item.hide.sc-z-select{display:none}.tree-list-reset-item.sc-z-select{padding:var(--space-unit) 0}z-list-element.sc-z-select{position:relative;display:block}z-list.sc-z-select z-list-element.sc-z-select::before{position:absolute;z-index:100;top:3px;left:-15px;width:8px;height:1em;border-bottom:1px solid var(--color-form-disabled01-icon);border-left:1px solid var(--color-form-disabled01-icon);content:\"\";cursor:pointer}z-list.sc-z-select z-list-element.sc-z-select::after{position:absolute;z-index:100;top:5px;left:-15px;width:8px;height:100%;border-left:1px solid var(--color-form-disabled01-icon);content:\"\";cursor:pointer}z-list.sc-z-select z-list-element.sc-z-select:last-child::after{display:none}z-list.sc-z-select>z-list-element.sc-z-select::before,z-list.sc-z-select>z-list-element.sc-z-select::after,z-list.sc-z-select>z-list-group.sc-z-select>z-list-element.sc-z-select::before,z-list.sc-z-select>z-list-group.sc-z-select>z-list-element.sc-z-select::after{display:none}z-list.sc-z-select>div.children-node.sc-z-select{padding-left:calc(var(--space-unit) * 2)}z-list-element.grouped-tree-parent-node.sc-z-select{padding-top:0;padding-left:calc(var(--space-unit) * 2)}z-list-element.sc-z-select>.list-element.sc-z-select{display:flex;justify-content:space-between;padding:calc(var(--space-unit) * 1.25) 0;cursor:pointer}z-list-element.sc-z-select>.list-element.sc-z-select:focus:focus-visible{box-shadow:var(--shadow-focus-primary);outline:none}z-list-element.sc-z-select>.list-element.sc-z-select .item.ellipsis.sc-z-select{overflow:hidden}z-list-element.sc-z-select .list-element.sc-z-select::after{position:absolute;top:0;right:-1px;display:block;width:100%;height:40px;content:\"\";transform:translateX(-100%)}z-list-element.tree-search-item.sc-z-select{padding-top:0}z-list-element.tree-search-item.sc-z-select .list-element.sc-z-select::after{position:absolute;top:8px;right:-25px;display:block;width:100%;height:40px;content:\"\";transform:translateX(-100%)}z-list-element.grouped-tree-parent-node.sc-z-select .list-element.sc-z-select::after{position:absolute;top:8px;right:-25px;display:block;width:100%;height:40px;content:\"\";transform:translateX(-100%)}z-list-element.sc-z-select:not([disabled])>.list-element.sc-z-select:hover,z-list-element.sc-z-select:not([disabled])>.list-element.sc-z-select:hover::after{z-index:-1;background-color:var(--color-form-surface03);cursor:pointer}.item-label.selected.sc-z-select{font-weight:bold}z-list-element.sc-z-select:focus{box-shadow:var(--shadow-focus-primary);outline:none}.item.ellipsis.sc-z-select{display:inline-block;overflow:hidden;max-width:100%;text-overflow:ellipsis;white-space:nowrap}z-list.sc-z-select>z-list-element.grouped-tree-parent-node.sc-z-select>.list-element.sc-z-select:hover::after,z-list-element.tree-search-item.sc-z-select .list-element.sc-z-select:hover::after,z-list.sc-z-select>z-list-group.sc-z-select>z-list-element.grouped-tree-parent-node.sc-z-select>.list-element.sc-z-select:hover::after{position:absolute;z-index:-1;top:8px;right:-18px;display:block;width:100%;height:40px;content:\"\";transform:translateX(-100%)}z-list-element.sc-z-select>.list-element.sc-z-select:hover::after{position:absolute;z-index:-1;top:0;right:0;display:block;width:100%;height:40px;content:\"\";transform:translateX(-100%)}.children-node.sc-z-select z-list-element.sc-z-select::before,.children-node.sc-z-select z-list-element.sc-z-select::after{left:-15px}.children-node.sc-z-select .children-node.sc-z-select z-list-element.sc-z-select::before,.children-node.sc-z-select .children-node.sc-z-select z-list-element.sc-z-select::after{left:-15px}.children-node.sc-z-select>z-list-element.sc-z-select{padding:0}";
const ZSelectStyle0 = stylesCss;

const ZSelect$1 = /*@__PURE__*/ proxyCustomElement(class ZSelect extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.optionSelect = createEvent(this, "optionSelect", 7);
        this.resetSelect = createEvent(this, "resetSelect", 7);
        this.itemsList = [];
        this.itemIdKeyMap = {};
        this.resetKey = -1;
        this.htmlid = `id-${randomId()}`;
        this.items = undefined;
        this.name = undefined;
        this.label = undefined;
        this.ariaLabel = "";
        this.disabled = false;
        this.readonly = false;
        this.placeholder = undefined;
        this.htmltitle = undefined;
        this.status = undefined;
        this.message = true;
        this.autocomplete = false;
        this.noresultslabel = "Nessun risultato";
        this.hasGroupItems = undefined;
        this.hasTreeItems = undefined;
        this.isfixed = false;
        this.resetItem = undefined;
        this.size = ControlSize.BIG;
        this.isOpen = false;
        this.selectedItem = null;
        this.focusedItemId = undefined;
        this.searchString = undefined;
        this.flattenedList = [];
        this.toggleSelectUl = this.toggleSelectUl.bind(this);
        this.handleSelectFocus = this.handleSelectFocus.bind(this);
    }
    watchItems() {
        this.itemsList = this.getInitialItemsArray();
        this.selectedItem = this.findSelectedItem(this.itemsList);
        this.flattenedList = this.flattenTreeItems(this.itemsList);
        this.itemIdKeyMap = {};
        this.flattenedList.forEach(({ item, key }) => {
            this.itemIdKeyMap[item.id] = key;
        });
    }
    getFocusedItemHandler(e) {
        this.focusedItemId = e.target.id;
    }
    /** get the input selected options */
    async getSelectedItem() {
        return this.selectedItem;
    }
    /** get the input value */
    async getValue() {
        return this.getSelectedValue();
    }
    /** set the input value */
    async setValue(value) {
        let values = [];
        if (typeof value === "string") {
            values.push(value);
        }
        else {
            values = value;
        }
        this.itemsList = this.getInitialItemsArray();
        if (values.length) {
            this.updateSelection(this.itemsList, values[0]);
        }
        this.selectedItem = this.findSelectedItem(this.itemsList);
    }
    emitOptionSelect() {
        this.optionSelect.emit({
            id: this.htmlid,
            selected: this.getSelectedValue(),
        });
    }
    emitResetSelect() {
        this.resetSelect.emit({
            id: this.htmlid,
        });
    }
    componentWillLoad() {
        this.watchItems();
    }
    componentWillRender() {
        this.filterItems(this.searchString);
    }
    getInitialItemsArray() {
        return typeof this.items === "string" ? JSON.parse(this.items) : this.items;
    }
    mapSelectedItemToItemsArray() {
        const initialItemsList = this.getInitialItemsArray();
        return initialItemsList.map((item) => {
            var _a;
            item.selected = item.id === ((_a = this.selectedItem) === null || _a === void 0 ? void 0 : _a.id);
            return item;
        });
    }
    getSelectedValue() {
        var _a;
        return (_a = this.selectedItem) === null || _a === void 0 ? void 0 : _a.id;
    }
    filterItems(searchString) {
        const prevList = this.mapSelectedItemToItemsArray();
        if (!(searchString === null || searchString === void 0 ? void 0 : searchString.length)) {
            this.itemsList = prevList;
            return;
        }
        if (this.hasTreeItems) {
            this.itemsList = this.filterTree(prevList, searchString);
        }
        else {
            this.itemsList = prevList
                .filter((item) => item.name.toUpperCase().includes(searchString.toUpperCase()))
                .map((item) => {
                item.name = this.getHighlightedText(item.name, searchString);
                return item;
            });
        }
        this.flattenedList = this.flattenTreeItems(this.itemsList);
        this.itemIdKeyMap = {};
        this.flattenedList.forEach(({ item, key }) => {
            this.itemIdKeyMap[item.id] = key;
        });
    }
    filterTree(items, searchString) {
        if (!items) {
            return [];
        }
        return items
            .map((item) => {
            const match = item.name.toUpperCase().includes(searchString.toUpperCase());
            const newItem = Object.assign({}, item);
            if (newItem.children && newItem.children.length > 0) {
                newItem.children = this.filterTree(newItem.children, searchString);
            }
            if (match) {
                newItem.name = this.getHighlightedText(newItem.name, searchString);
            }
            if (match || (newItem.children && newItem.children.length > 0)) {
                return newItem;
            }
            return null;
        })
            .filter((item) => item !== null);
    }
    getHighlightedText(text, search) {
        const upperText = text.toUpperCase();
        const upperSearch = search.toUpperCase();
        const start = upperText.indexOf(upperSearch);
        if (start === -1) {
            return text;
        }
        const end = start + search.length;
        return text.substring(0, start) + `<strong>${text.substring(start, end)}</strong>` + text.substring(end);
    }
    hasAutocomplete() {
        return boolean(this.autocomplete) === true;
    }
    handleInputChange(e) {
        this.searchString = e.detail.value;
        if (!this.isOpen) {
            this.toggleSelectUl();
        }
    }
    updateSelection(items, selectedId) {
        if (items) {
            items.forEach((item) => {
                item.selected = item.id === selectedId;
                if (item.children && item.children.length > 0) {
                    this.updateSelection(item.children, selectedId);
                }
            });
        }
    }
    findSelectedItem(items) {
        if (items) {
            for (const item of items) {
                if (item.selected) {
                    return item;
                }
                if (item.children && item.children.length > 0) {
                    const found = this.findSelectedItem(item.children);
                    if (found) {
                        return found;
                    }
                }
            }
        }
        return null;
    }
    selectItem(selected) {
        if (selected === null || selected === void 0 ? void 0 : selected.disabled) {
            return;
        }
        this.itemsList = this.getInitialItemsArray();
        if (selected) {
            this.updateSelection(this.itemsList, selected.id);
        }
        this.selectedItem = this.findSelectedItem(this.itemsList);
        this.emitOptionSelect();
        this.toggleSelectUl(true);
        if (this.searchString) {
            this.searchString = null;
        }
    }
    flattenTreeItems(items) {
        const flatItems = [];
        let index = 0;
        function flatten(subItems) {
            subItems.forEach((itm) => {
                flatItems.push({ item: itm, key: index++ });
                if (itm.children && itm.children.length > 0) {
                    flatten(itm.children);
                }
            });
        }
        flatten(items);
        return flatItems;
    }
    arrowsSelectNav(e, idOrReset) {
        const showResetIcon = this.resetItem && !!this.selectedItem;
        const arrows = [KeyboardCode.ARROW_DOWN, KeyboardCode.ARROW_UP];
        if (!arrows.includes(e.key)) {
            return;
        }
        e.preventDefault();
        e.stopPropagation();
        const flatItems = [...this.flattenedList].filter((f) => !f.item.disabled);
        if (this.resetItem && showResetIcon) {
            flatItems.unshift({
                item: { id: "__RESET_ITEM__" },
                key: this.resetKey,
            });
        }
        let currentIndex;
        if (typeof idOrReset === "number") {
            currentIndex = flatItems.findIndex((f) => f.key === idOrReset);
        }
        else {
            const k = this.itemIdKeyMap[idOrReset];
            currentIndex = flatItems.findIndex((f) => f.key === k);
        }
        if (!this.isOpen) {
            this.toggleSelectUl();
            if (currentIndex === -1) {
                currentIndex = -1;
            }
        }
        const lastIndex = flatItems.length - 1;
        let newIndex = currentIndex;
        if (e.key === KeyboardCode.ARROW_DOWN) {
            do {
                newIndex = newIndex === lastIndex ? 0 : newIndex + 1;
            } while (flatItems[newIndex].item.disabled);
        }
        else {
            do {
                newIndex = newIndex <= 0 ? lastIndex : newIndex - 1;
            } while (flatItems[newIndex].item.disabled);
        }
        this.focusSelectItem(flatItems[newIndex].key);
    }
    focusSelectItem(key) {
        var _a;
        (_a = this.host.querySelector(`#${this.htmlid}_key_${key}`)) === null || _a === void 0 ? void 0 : _a.focus();
    }
    toggleSelectUl(selfFocusOnClose = false) {
        var _a;
        if (this.disabled || this.readonly) {
            return;
        }
        if (!this.isOpen) {
            document.addEventListener("click", this.handleSelectFocus);
            document.addEventListener("keyup", this.handleSelectFocus);
        }
        else {
            document.removeEventListener("click", this.handleSelectFocus);
            document.removeEventListener("keyup", this.handleSelectFocus);
            if (selfFocusOnClose) {
                (_a = this.host.querySelector(`#${this.htmlid}_input`)) === null || _a === void 0 ? void 0 : _a.focus();
            }
        }
        this.focusedItemId = "";
        this.isOpen = !this.isOpen;
    }
    handleInputClick(e) {
        if (e.target.closest(".reset-icon")) {
            e.stopPropagation();
            return;
        }
        this.toggleSelectUl();
    }
    handleSelectFocus(e) {
        const clickedElement = getClickedElement();
        if (clickedElement === null || clickedElement === void 0 ? void 0 : clickedElement.hasAttribute("disabled")) {
            return;
        }
        if (e instanceof KeyboardEvent && e.key === KeyboardCode.ESC) {
            e.stopPropagation();
            return this.toggleSelectUl(true);
        }
        if (e instanceof KeyboardEvent && (e.key === KeyboardCode.ENTER || e.key !== KeyboardCode.TAB)) {
            return;
        }
        if (!getElementTree(clickedElement).find((elem) => elem.nodeName.toLowerCase() === "z-input" && elem.id === `${this.htmlid}_input`)) {
            this.toggleSelectUl(e instanceof MouseEvent);
        }
    }
    scrollToLetter(letter) {
        const foundItem = this.itemsList.findIndex((item) => item.name.charAt(0) === letter);
        if (foundItem > -1) {
            this.focusSelectItem(this.itemIdKeyMap[this.itemsList[foundItem].id]);
        }
    }
    renderInput() {
        return (h("z-input", { class: {
                "active-select": this.isOpen,
                "cursor-select": !this.autocomplete,
            }, id: `${this.htmlid}_input`, htmlid: `${this.htmlid}_select_input`, placeholder: this.placeholder, value: !this.isOpen && this.selectedItem ? this.selectedItem.name.replace(/<[^>]+>/g, "") : null, label: this.label, "aria-expanded": this.isOpen ? "true" : "false", "aria-label": this.ariaLabel, "aria-controls": `${this.htmlid}_list`, "aria-autocomplete": this.hasAutocomplete() ? "list" : "none", "aria-activedescendant": this.isOpen ? this.focusedItemId : "", icon: this.isOpen ? "caret-up" : "caret-down", hasclearicon: this.hasAutocomplete(), message: false, name: this.name, disabled: this.disabled, readonly: this.readonly || (!this.hasAutocomplete() && this.isOpen), status: this.isOpen ? undefined : this.status, role: "combobox", size: this.size, onClick: (e) => {
                this.handleInputClick(e);
            }, onKeyUp: (e) => {
                if (e.key !== KeyboardCode.ENTER) {
                    e.preventDefault();
                }
                handleKeyboardSubmit(e, this.toggleSelectUl);
            }, onKeyDown: (e) => {
                const current = this.selectedItem
                    ? this.itemIdKeyMap[this.selectedItem.id]
                    : this.resetItem
                        ? this.resetKey
                        : "";
                return this.arrowsSelectNav(e, current);
            }, onInputChange: (e) => {
                this.handleInputChange(e);
            }, onKeyPress: (e) => {
                if (!this.hasAutocomplete()) {
                    e.preventDefault();
                    this.scrollToLetter(String.fromCharCode(e.keyCode));
                }
            } }));
    }
    renderSelectUl() {
        return (h("div", { class: this.isOpen ? "open" : "closed" }, h("div", { class: {
                "ul-scroll-wrapper": true,
                "fixed": this.isfixed,
            } }, h("z-list", { role: "listbox", "aria-label": this.ariaLabel || this.label, tabindex: this.disabled || this.readonly || !this.isOpen ? -1 : 0, id: `${this.htmlid}_list`, "aria-multiselectable": false, size: this.listSizeType(), class: {
                "disabled": this.disabled,
                "readonly": this.readonly,
                [`input-${this.status}`]: !this.isOpen && !!this.status,
                "z-scrollbar": true,
            } }, this.resetItem && this.renderResetItem(), this.renderSelectUlItems()))));
    }
    renderResetItem() {
        return (h("z-list-element", { class: {
                "hide": !this.selectedItem || !this.resetItem,
                "reset-item": true,
                "reset-item-margin": !this.hasGroupItems,
            }, clickable: true, disabled: false, dividerType: ListDividerType.ELEMENT, role: "option", tabindex: "0", "aria-selected": "false", id: `${this.htmlid}_key_${this.resetKey}`, size: this.hasTreeItems ? ListSize.MEDIUM : this.listSizeType(), onClickItem: () => {
                this.selectedItem = null;
                this.searchString = null;
                this.emitResetSelect();
            }, onKeyDown: (e) => this.arrowsSelectNav(e, this.resetKey) }, h("div", { class: {
                "reset-item-content": true,
                "tree-list-reset-item": this.hasTreeItems,
            } }, h("z-icon", { name: "multiply-circled" }), h("span", null, this.resetItem))));
    }
    renderItem(item, lastItem) {
        const thisItemKey = this.itemIdKeyMap[item.id];
        return (h("z-list-element", { clickable: !item.disabled, disabled: item.disabled, dividerType: lastItem ? ListDividerType.HEADER : ListDividerType.ELEMENT, role: "option", tabindex: item.disabled || !this.isOpen ? -1 : 0, "aria-selected": item.selected ? "true" : "false", id: `${this.htmlid}_key_${thisItemKey}`, size: this.listSizeType(), onClickItem: () => this.selectItem(item), onKeyDown: (e) => this.arrowsSelectNav(e, thisItemKey) }, h("div", { class: "list-element-container" }, h("div", { class: {
                "selected": !!item.selected,
                "list-element-content": true,
            }, innerHTML: item.name }), item.icon && h("z-tag", { icon: item.icon }))));
    }
    listSizeType() {
        if (this.hasTreeItems) {
            return ListSize.NONE;
        }
        if (this.size === ControlSize.SMALL || this.size === ControlSize.X_SMALL) {
            return ListSize.SMALL;
        }
        return ListSize.MEDIUM;
    }
    //eslint-disable-next-line
    renderSelectUlItems() {
        if (!this.itemsList.length) {
            return this.renderNoSearchResults();
        }
        if (this.hasGroupItems && !this.hasTreeItems) {
            return this.renderSelectGroupItems();
        }
        else if (this.hasGroupItems && this.hasTreeItems) {
            return this.renderGroupedTree();
        }
        return this.itemsList.map((item, index, array) => {
            const isLastItem = index === array.length - 1;
            const parentHasSiblings = array.length > 1;
            if (this.hasTreeItems) {
                return this.renderTreeItems(item, isLastItem, parentHasSiblings, true);
            }
            return this.renderItem(item, isLastItem);
        });
    }
    renderTreeItems(item, isLastChild, parentHasSiblings, isTopLevel) {
        var _a, _b;
        const thisItemKey = this.itemIdKeyMap[item.id];
        const hasDivider = this.hasGroupItems
            ? undefined
            : this.hasGroupItems
                ? isLastChild && !parentHasSiblings
                    ? ListDividerType.ELEMENT
                    : undefined
                : isTopLevel && parentHasSiblings && !isLastChild
                    ? ListDividerType.ELEMENT
                    : undefined;
        return (h("z-list-element", { clickable: !item.disabled, disabled: item.disabled, class: {
                "grouped-tree-parent-node": this.hasGroupItems && !!((_a = item.children) === null || _a === void 0 ? void 0 : _a.length),
                "tree-search-item": this.hasGroupItems && isTopLevel && !((_b = item.children) === null || _b === void 0 ? void 0 : _b.length) && !!this.searchString,
            }, size: this.listSizeType(), dividerType: hasDivider, hasTreeItems: this.hasTreeItems }, h("div", { id: `${this.htmlid}_key_${thisItemKey}`, role: "option", class: "list-element", tabIndex: 0, onClick: () => this.selectItem(item), onKeyDown: (e) => {
                this.arrowsSelectNav(e, thisItemKey);
                if (e.key === KeyboardCode.ENTER) {
                    this.selectItem(item);
                }
            } }, h("span", { class: "item ellipsis" }, h("span", { class: {
                "item-label": true,
                "selected": !!item.selected,
            }, title: item.name, innerHTML: item.selected ? `<strong>${item.name}</strong>` : item.name })), item.icon && h("z-tag", { icon: item.icon })), item.children && item.children.length > 0 ? (h("z-list", null, h("div", { class: "children-node" }, item.children.map((child, index, arr) => this.renderTreeItems(child, index === arr.length - 1, arr.length > 1, false // isTopLevel = false for children
        ))))) : null));
    }
    renderGroupedTree() {
        const grouped = this.itemsList.reduce((acc, item) => {
            const category = item.category || "Altra categoria";
            acc[category] = acc[category] || [];
            acc[category].push(item);
            return acc;
        }, {});
        return Object.entries(grouped).map(([category, items], index, entries) => {
            const parentHasSiblings = Object.values(grouped).some((groupItems) => groupItems.length > 1);
            // const parentHasSiblings = items.length > 1;
            return (h("z-list-group", { "divider-type": index === entries.length - 1 ? undefined : ListDividerType.ELEMENT, hasTreeItems: true }, h("span", { class: "body-3-sb z-list-group-title", slot: "header-title" }, category), h("z-list", null, items.map((item, i, arr) => [
                this.renderTreeItems(item, i === arr.length - 1, parentHasSiblings, true),
                i < arr.length - 1 ? (h("z-divider", { key: `divider-${i}`, style: { zIndex: "100", height: "var(--border-size-small)" } })) : null,
            ])), index !== entries.length - 1 && h("z-divider", { style: { zIndex: "100", height: "var(--border-size-small)" } })));
        });
    }
    renderSelectGroupItems() {
        const newData = this.itemsList.reduce((group, item, index, array) => {
            var _a;
            const { category } = item;
            const lastItem = array.length === index + 1;
            const zListItem = this.renderItem(item, lastItem);
            group[category] = (_a = group[category]) !== null && _a !== void 0 ? _a : [];
            group[category].push(zListItem);
            return group;
        }, {});
        return Object.entries(newData).map(([key, value]) => {
            return (h("z-list-group", { "divider-type": ListDividerType.ELEMENT }, h("span", { class: "body-3-sb z-list-group-title", slot: "header-title" }, key), value.map((item) => item)));
        });
    }
    renderNoSearchResults() {
        return (h("z-list-element", { color: "color-primary01", class: "no-results", size: this.hasTreeItems ? ListSize.MEDIUM : this.listSizeType() }, h("z-icon", { name: "multiply-circle", fill: "color-primary01-icon" }), this.noresultslabel));
    }
    renderMessage() {
        if (boolean(this.message) === false) {
            return;
        }
        return (h("z-input-message", { message: boolean(this.message) === true ? undefined : this.message, status: this.status, class: this.size, disabled: this.disabled }));
    }
    render() {
        return (h("div", { key: 'a8109cbdbf4541195123f7dc823a05f630858f05', class: "select-wrapper" }, this.renderInput(), this.renderSelectUl(), this.renderMessage()));
    }
    get host() { return this; }
    static get watchers() { return {
        "items": ["watchItems"]
    }; }
    static get style() { return ZSelectStyle0; }
}, [2, "z-select", {
        "htmlid": [1],
        "items": [1],
        "name": [1],
        "label": [1],
        "ariaLabel": [1, "aria-label"],
        "disabled": [4],
        "readonly": [4],
        "placeholder": [1],
        "htmltitle": [1],
        "status": [1],
        "message": [8],
        "autocomplete": [4],
        "noresultslabel": [1],
        "hasGroupItems": [4, "has-group-items"],
        "hasTreeItems": [4, "has-tree-items"],
        "isfixed": [4],
        "resetItem": [1, "reset-item"],
        "size": [1],
        "isOpen": [32],
        "selectedItem": [32],
        "focusedItemId": [32],
        "searchString": [32],
        "flattenedList": [32],
        "getSelectedItem": [64],
        "getValue": [64],
        "setValue": [64]
    }, [[0, "ariaDescendantFocus", "getFocusedItemHandler"]], {
        "items": ["watchItems"]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["z-select", "z-divider", "z-icon", "z-input", "z-input-message", "z-list", "z-list-element", "z-list-group", "z-tag"];
    components.forEach(tagName => { switch (tagName) {
        case "z-select":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, ZSelect$1);
            }
            break;
        case "z-divider":
            if (!customElements.get(tagName)) {
                defineCustomElement$9();
            }
            break;
        case "z-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$8();
            }
            break;
        case "z-input":
            if (!customElements.get(tagName)) {
                defineCustomElement$7();
            }
            break;
        case "z-input-message":
            if (!customElements.get(tagName)) {
                defineCustomElement$6();
            }
            break;
        case "z-list":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "z-list-element":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "z-list-group":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "z-tag":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
    } });
}

const ZSelect = ZSelect$1;
const defineCustomElement = defineCustomElement$1;

export { ZSelect, defineCustomElement };

//# sourceMappingURL=z-select.js.map