import { EventEmitter } from "../../../stencil-public-runtime";
import { TreeListItem } from "../../../beans";
export declare class ZTreeList {
    host: HTMLZTreeListElement;
    /** Items to render, if they have the url property they will be rendered as clickable links */
    items: TreeListItem[] | string;
    /** Used for aria-labelledby attribute, sets name in "navigation" */
    htmlAriaLabelledby: string;
    /** Used for aria-label attribute, sets name in "tree" */
    htmlSectionTitle: string;
    /** Emitted on item click, it return the id, name and url of the clicked item */
    treeItemClicked: EventEmitter<{
        id: string;
        name: string;
        url: string;
    }>;
    private parsedItems;
    private htmlTag;
    watchItems(): void;
    componentWillLoad(): void;
    private handleClick;
    private getFocusableElements;
    private getAncestor;
    private handleArrowNav;
    private renderTreeList;
    render(): HTMLZTreeListElement;
}
