import { type ZPagination } from ".";
import { CSSVarsArguments } from "../../utils/storybook-utils";
import "./index";
type ZPaginationStoriesArgs = ZPagination & CSSVarsArguments<"--z-pagination-background-color" | "--z-pagination-background-color-hover">;
declare const StoryMeta: {
    title: string;
    component: string;
    argTypes: {
        totalPages: {
            control: {
                type: "number";
                min: number;
            };
        };
        visiblePages: {
            control: {
                type: "number";
                min: number;
            };
            if: {
                arg: string;
                truthy: false;
            };
        };
        currentPage: {
            control: {
                type: "number";
                min: number;
            };
        };
        skip: {
            control: {
                type: "number";
                min: number;
            };
        };
        edges: {
            if: {
                arg: string;
                truthy: false;
            };
        };
        split: {
            control: {
                type: "number";
                min: number;
            };
        };
        "--z-pagination-background-color": import("@storybook/csf").Args;
        "--z-pagination-background-color-hover": import("@storybook/csf").Args;
    };
    args: {
        label: string;
        navArrows: true;
        totalPages: number;
        visiblePages: number;
        currentPage: number;
        goToPage: false;
        split: any;
        skip: number;
        edges: false;
        "--z-pagination-background-color": string;
        "--z-pagination-background-color-hover": string;
    };
    render: (args: ZPaginationStoriesArgs) => import("lit-html").TemplateResult<1>;
};
export default StoryMeta;
export declare const VisiblePages: {
    parameters: {
        controls: {
            exclude: string[];
        };
    };
};
/**
 * > Note that enabling `split` will shut off `visiblePages` and `edges`.
 */
export declare const Split: {
    args: {
        split: number;
    };
    parameters: {
        controls: {
            exclude: string[];
        };
    };
};
export declare const Edges: {
    args: {
        edges: true;
    };
    parameters: {
        controls: {
            exclude: string[];
        };
    };
};
export declare const Skip: {
    args: {
        skip: number;
    };
};
